Subject: Re: Question: Is it possible to host a writable git repo over both http and ssh?

From: Rogan Dawes <[email-masked]>
Date: Thu, 26 Mar 2009 11:46:25 +0200

Robin Rosenberg wrote:
> torsdag 26 mars 2009 05:56:51 skrev Jeff King <[email-masked]>:
>> On Wed, Mar 25, 2009 at 11:55:29PM -0500, Mike Gaffney wrote:
>>
>>> I'm actually trying to take what Sean did with gerrit and extract a
>>> full Java/MinaSSHD based server that doesn't require a real user
>>> account and is configurable by spring. So yes, I'm using JGit on the
>>> server.
>> Ah. In that case, I don't know whether JGit respects all hooks. You
>> should ask Shawn (Shawn, we are talking about a post-update to run
>> update-server-info). :)
> 
> Arguably it should. but it doesn't. Then there is a question as to what
> format those hooks should be. Shell scripts would run into platform
> issues and jgit based stuff should have as little as possible of that, but
> a similar mechanism should exist.
> 
> -- robin
> 

Maybe support executing scripts via Bean Scripting Framework?

That would allow scripts to be written in any of the supported
languages, as long as the appropriate interpreter is present.

e.g. BeanShell, Groovy, Jython, etc

See http://jakarta.apache.org/bsf/

If you define an interface for each hook, the scripts could implement
the interface, and execute that way.

Here is an example, mishmashed from
<http://www.beanshell.org/examples/actionhandler.html> and
<http://jvm-languages.com/wiki/Bean_Scripting_Framework#Interacting_with_Complex_Objects>:

======8x===== Java code =========
public class BSFFileUtils
{
   public Object evalFile (BSFManager manager, File file)
       throws IOException
   {
      String fileName = file.getPath();

      String language = manager.getLangFromFilename(fileName);
      String code = extractFileContents(file);

      return manager.eval(language, fileName, 0, 0, code);
   }

   private String extractFileContents (File file)
      throws IOException
   {
      StringBuffer buf = new StringBuffer();

      BufferedReader r = new BufferedReader(new FileReader(file));
      try {
         int len;
         char[] chars = new char[8192];

         while ((len = r.read(chars, 0, chars.length)) != -1) {
           buf.append(chars, 0, len);
         }

         return buf.toString();
      } finally {
          r.close();
      }
   }
}

public static void main (String[] args)
{
   String directory = args[0];
   File file = new File("actionHandler.bsh");

   BSFManager manager = new BSFManager();

   ActionListener listener = (ActionListener)
BSFFileUtils.evalFile(manager, file);

   JButton button = new JButton("MyButton");
   button.addActionListener(listener);

   JFrame f = new JFrame();
   f.getContentPane().add( button );
   f.show();
}

======8x===== BeanShell code ========= actionHandler.bsh

import java.awt.event.ActionListener;

actionPerformed( e ) {
    print("Button Pressed: " + e);
}

return (ActionListener)this;

======8x==============================

Having said all this, it is probably worth implementing
update-server-info in Java, so as to avoid having to shell out to
perform this action, and keep it all platform-independent.

Rogan